<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="fr">
<head>
<!-- Generated by javadoc (11.0.11) on Sat Dec 04 19:21:21 CET 2021 -->
<title>Hexastore</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2021-12-04">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
<script type="text/javascript" src="../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Hexastore";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Hexastore.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">qengine.index</a></div>
<h2 title="Class Hexastore" class="title">Class Hexastore</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>qengine.index.Hexastore</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><code><a href="Index.html" title="interface in qengine.index">Index</a></code></dd>
</dl>
<hr>
<pre>public class <span class="typeNameLabel">Hexastore</span>
extends java.lang.Object
implements <a href="Index.html" title="interface in qengine.index">Index</a></pre>
<div class="block">Indexage d'un dictionnaire avec un hexastore, constitué de toutes les
 permutations possibles d'un <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore"><code>TripleStore</code></a>. Cela va permettre de
 retrouver une projection (deux constantes et une variable) en temps constant.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Pierre Romestant, Gabriel Darbord</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#OPS">OPS</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#OSP">OSP</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#POS">POS</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#PSO">PSO</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#SOP">SOP</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#SPO">SPO</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">Hexastore</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#add(int,int,int)">add</a></span>&#8203;(int&nbsp;subject,
   int&nbsp;predicate,
   int&nbsp;object)</code></th>
<td class="colLast">
<div class="block">Ajoute un triplet d'indices à l'index s'il n'est pas déjà présent.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>java.util.Set&lt;java.lang.Integer&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#project(qengine.query.pattern.Pattern)">project</a></span>&#8203;(<a href="../query/pattern/Pattern.html" title="interface in qengine.query.pattern">Pattern</a>&nbsp;pattern)</code></th>
<td class="colLast">
<div class="block">Effectue la projection d'un patron.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#size()">size</a></span>()</code></th>
<td class="colLast">
<div class="block">Retourne la taille de l'indexage.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#toString()">toString</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="OPS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>OPS</h4>
<pre>private final&nbsp;<a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a> OPS</pre>
</li>
</ul>
<a id="OSP">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>OSP</h4>
<pre>private final&nbsp;<a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a> OSP</pre>
</li>
</ul>
<a id="POS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>POS</h4>
<pre>private final&nbsp;<a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a> POS</pre>
</li>
</ul>
<a id="PSO">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>PSO</h4>
<pre>private final&nbsp;<a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a> PSO</pre>
</li>
</ul>
<a id="SOP">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>SOP</h4>
<pre>private final&nbsp;<a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a> SOP</pre>
</li>
</ul>
<a id="SPO">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>SPO</h4>
<pre>private final&nbsp;<a href="triplestore/TripleStore.html" title="class in qengine.index.triplestore">TripleStore</a> SPO</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Hexastore</h4>
<pre>public&nbsp;Hexastore()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="size()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre class="methodSignature">public&nbsp;int&nbsp;size()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="Index.html#size()">Index</a></code></span></div>
<div class="block">Retourne la taille de l'indexage.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="Index.html#size()">size</a></code>&nbsp;in interface&nbsp;<code><a href="Index.html" title="interface in qengine.index">Index</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>la taille de l'indexage</dd>
</dl>
</li>
</ul>
<a id="add(int,int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;add&#8203;(int&nbsp;subject,
                   int&nbsp;predicate,
                   int&nbsp;object)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="Index.html#add(int,int,int)">Index</a></code></span></div>
<div class="block">Ajoute un triplet d'indices à l'index s'il n'est pas déjà présent.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="Index.html#add(int,int,int)">add</a></code>&nbsp;in interface&nbsp;<code><a href="Index.html" title="interface in qengine.index">Index</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>subject</code> - un sujet</dd>
<dd><code>predicate</code> - un prédicat</dd>
<dd><code>object</code> - un objet</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>vrai s'il a été ajouté</dd>
</dl>
</li>
</ul>
<a id="project(qengine.query.pattern.Pattern)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>project</h4>
<pre class="methodSignature">public&nbsp;java.util.Set&lt;java.lang.Integer&gt;&nbsp;project&#8203;(<a href="../query/pattern/Pattern.html" title="interface in qengine.query.pattern">Pattern</a>&nbsp;pattern)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="Index.html#project(qengine.query.pattern.Pattern)">Index</a></code></span></div>
<div class="block">Effectue la projection d'un patron.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="Index.html#project(qengine.query.pattern.Pattern)">project</a></code>&nbsp;in interface&nbsp;<code><a href="Index.html" title="interface in qengine.index">Index</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pattern</code> - un triplet avec une inconnue</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>l'ensemble des valeurs possibles pour l'inconnue</dd>
</dl>
</li>
</ul>
<a id="toString()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>toString</h4>
<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;toString()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Hexastore.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
